#!/bin/sh
APPS_NAME="busybox"
if [ -e sysconfig.sh ]; then
	. ./sysconfig.sh
	. ./config.sh
else
	echo "Application "$APPS_NAME" not configured"
	exit 1;
fi
DEF_CONFIG="ifx_config"

display_info "----------------------------------------------------------------------"
display_info "-----------------------   build busybox 1.15.3   ---------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

cp $CONFIG/$MODELS/busybox_config .config

# ETHTOOL_DIR=`cd  ./networking/ethtool && pwd`
CONFIG_FILE=config.sh
BB_CONFIG_FILE=.config
if [ $BUILD_CLEAN -eq 1 ]; then
		make "$clean"
		#cd "$ETHTOOL_DIR" && ./build.sh $@ && cd -
#		if [ -e "$ETHTOOL_DIR"/Makefile ];then
#			make -C "$ETHTOOL_DIR" "$clean"
#		fi
		[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi
if [ "$1" = "config_only" -o $BUILD_CONFIGURE -eq 1 ]; then
		if [ "$DEF_CONFIG" -nt ./.config ]; then
			display_info "Using default config"
			sleep 1
			cp -Lf "$DEF_CONFIG" .config
		fi
		chmod a+w .config
		set_config `pwd`/.config \
		CONFIG_CROSS_COMPILER_PREFIX \"$COMPILER_PREFIX\"
		set_config `pwd`/.config \
		CONFIG_EXTRA_CFLAGS_OPTIONS \"$IFX_CFLAGS\"
		make oldconfig
		#make dep
		ifx_error_check $?
fi
if [ "$1" = "config_only" ] ; then
	exit 0
fi
disable_config()
{
	FILE="$1"
	OPTION="$2"
	sed -i "/$OPTION/d" "$FILE"
	echo "# $OPTION is not set" >> "$FILE"
}
enable_config()
{
	FILE="$1"
	OPTION="$2"
	sed -i "/$OPTION/d" "$FILE"
	echo "$OPTION=y" >> "$FILE"
	}
if [ `grep "CONFIG_TFTPD=y" "$CONFIG_FILE"` ];then
	enable_config "$BB_CONFIG_FILE" CONFIG_TFTPD
else
	disable_config "$BB_CONFIG_FILE" CONFIG_TFTPD
fi
if [ `grep "CONFIG_CGI_HTTPS=y" "$CONFIG_FILE"` ];then
	enable_config "$BB_CONFIG_FILE" CONFIG_CGI_HTTPS
else
	disable_config "$BB_CONFIG_FILE" CONFIG_CGI_HTTPS
fi
if [ `grep "CONFIG_DNSD=y" "$CONFIG_FILE"` ];then
	enable_config "$BB_CONFIG_FILE" CONFIG_DNSD
else
	disable_config "$BB_CONFIG_FILE" CONFIG_DNSD
fi
		

grep -q 'CONFIG_ETHTOOL=y' .config
ETHTOOL=$?
if [ $ETHTOOL -eq 0 -a $BUILD_CONFIGURE -eq 1 ];then
	cd $ETHTOOL_DIR
	"$ETHTOOL_DIR"/configure
	make AR="$IFX_AR" AS="$IFX_AS" LD="$IFX_LD" \
	NM="$IFX_NM" CC="$IFX_CC" BUILDCC="$IFX_HOSTCC" \
	RANLIB="$IFX_RANLIB" -C "$ETHTOOL_DIR" all
	ifx_error_check $?
	cd -
fi
if [ "$CONFIG_BB_SMALLFP" = "y" ]; then
	IFX_CFLAGS="$IFX_CFLAGS -DIFX_SMALL_FOOTPRINT -DIFX_SMALL_AREASIZE -DIFX_ENVSPECIAL_MEM"
fi

make AR="$IFX_AR" AS="$IFX_AS" LD="$IFX_LD" NM="$IFX_NM" CC="$IFX_CC" BUILDCC="$IFX_HOSTCC" GCC="$IFX_CC" CXX="$IFX_CXX" CPP="$IFX_CPP" RANLIB="$IFX_RANLIB" IFX_CFLAGS="$IFX_CFLAGS" IFX_LDFLAGS="$IFX_LDFLAGS" CONFIG_PREFIX="$BUILD_ROOTFS_DIR" install 
ifx_error_check $? 
